#include "bess.h"
#include "bessstubs.h"
#include "bessproto.h"
#include "bess2gts.h"

static int
write_vs (BESSP bess, FILE *stream)
{
  MVP mv;
  LOC l;
  mv = NULL;
  while ((mv = bess_next_mv (bess, mv))) {
    bess_mv_get_loc (mv, &l);
    fprintf (stream, "%g %g %g\n", l.x, l.y, l.z);
  }
  return TRUE;
}


static void
write_ts (BESSP bess, FILE *stream)
{
  MEP me[3];
  int i, id;
  MFP mf;
  
  mf = NULL;
  while ((mf = bess_next_mf (bess, mf))) {
    bess_mf_get_me (mf, me);
    FOR (i, 3) {
      id = (int) bess_me_get_ap (me[i]);
      fprintf (stream, "%d ", id);
    }
    fprintf (stream, "\n");
  }
}

static void
write_es (BESSP bess, FILE *stream)
{
  MVP mv[3];
  int i, supplied;
  int id;
  MEP me;
  
  me = NULL;
  while ((me = bess_next_me (bess, me))) {
    supplied = bess_me_get_mv (me, mv);
    FOR (i, 2) {
      id = (int) bess_mv_get_ap (mv[i]);
      fprintf (stream, "%d ", id);
    }
    fprintf (stream, "\n");
  }
}

static void
counts (BESSP bess, FILE *stream)
{
  MVP mv;
  int nv = 0;
  MEP me;
  int ne = 0;
  MFP mf;
  int nf = 0;
  
  mv = NULL;
  while ((mv = bess_next_mv (bess, mv))) {
    nv++;
    bess_mv_set_ap(mv, nv);
  }
  me = NULL;
  while ((me = bess_next_me (bess, me))) {
    ne++;
    bess_me_set_ap(me, ne);
  }
  mf = NULL;
  while ((mf = bess_next_mf (bess, mf))) {
    nf++;
  }
  
  fprintf (stream, "%d %d %d\n", nv, ne, nf);
}

int
bess_to_gts (BESSP bess, FILE *stream)
{
  counts   (bess, stream);
  write_vs (bess, stream);
  write_es (bess, stream);
  write_ts (bess, stream);
  
  return TRUE;
}
