#ifndef GLEB_H
#  define GLEB_H


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <limits.h>
#include <sys/stat.h>
#include <unistd.h>
#include <float.h>

#if HAVE_STRING_H
#      include <string.h>
#else
#  if HAVE_STRINGS_H
#         include <strings.h>
#  endif
#endif

#include "newP.h"              /* Ckit library */
#include "ioP.h"              /* Ckit library */
#include "listP.h"              /* Ckit library */
#include "dictP.h"              /* Ckit library */
#include "hashP.h"              /* Ckit library */
#define VECMAC_VECTOR_TYPE 1
#include "vecmacP.h" 
#define WANT_VECTP_ALIASES
#include "vectP.h" /* to be able to use vector library routines. */
#include "tokensP.h"            /* Ckit library */
#include "expevalP.h" /* to be able to use expeval library routines. */
#include "gaussP.h" /* to be able to use gauss library routines. */
#include "randP.h" /* to be able to use rand library routines. */


#undef FOR
#define FOR(i_, n_) for (i_ = 0; i_ < n_; i_++)

#ifndef min
#   define min(A,B) (((A) < (B)) ? (A) : (B))
#endif
#ifndef max
#   define max(A,B) (((A) > (B)) ? (A) : (B))
#endif

typedef double (*gleb_h_hat_func) (void *data, double x, double y, double z);

struct gleb_t;
typedef struct gleb_t *GLEBP;

GLEBP
gleb_new (gleb_h_hat_func h_hat_func, void *h_hat_func_data);

int
gleb_add (GLEBP gleb, CkitPoint3 pts[3]);

int
gleb_split (GLEBP gleb);

void *
gleb_next (GLEBP gleb, CkitPoint3 pts[3], void *prev);

void
gleb_free (GLEBP gleb);

#endif

