

#ifndef GENWRAP_TYPE
#  error GENWRAP_TYPE must be defined to able to use listwrap
#endif

#ifndef GENWRAP_PREFIX
#  error GENWRAP_PREFIX must be defined to able to use listwrap
#endif

#ifndef GENWRAP_LIST_TYPE
#  error GENWRAP_LIST_TYPE must be defined to able to use listwrap
#endif


#undef DCL
#define DCL(prefix, f) GLUE(GLUE(prefix,p_),f)

#undef STRINGIZE
#define STRINGIZE(s) #s

#undef SPLURGE
#define SPLURGE(TYPE)                                                   \
                                                                        \
typedef LIST GLUE(TYPE,_l_t);                                           \
                                                                        \
static void                                                             \
DCL(GENWRAP_PREFIX, l_add) (GENWRAP_LIST_TYPE(TYPE) list, TYPE  obj)    \
{                                                                       \
  add_to_tail (list, obj);                                              \
}                                                                       \
                                                                        \
static GENWRAP_LIST_TYPE(TYPE)                                          \
DCL(GENWRAP_PREFIX, l_make) (void) {                                    \
                      return (GENWRAP_LIST_TYPE(TYPE)) make_list (); }  \
                                                                        \
                                                                        \
static TYPE                                                             \
DCL(GENWRAP_PREFIX, l_next) (GENWRAP_LIST_TYPE(TYPE) list, TYPE obj)    \
{                                                                       \
  return (TYPE) get_list_next (list, obj);                              \
}                                                                       \
                                                                        \
static TYPE                                                             \
DCL(GENWRAP_PREFIX, l_prev) (GENWRAP_LIST_TYPE(TYPE) list, TYPE obj)    \
{                                                                       \
  return (TYPE) get_list_prev (list, obj);                              \
}                                                                       \
                                                                        \
static TYPE                                                             \
DCL(GENWRAP_PREFIX, l_head) (GENWRAP_LIST_TYPE(TYPE) list)              \
{                                                                       \
  return (TYPE) get_list_head (list);                                   \
}                                                                       \
                                                                        \
static TYPE                                                             \
DCL(GENWRAP_PREFIX, l_tail) (GENWRAP_LIST_TYPE(TYPE) list)              \
{                                                                       \
  return (TYPE) get_list_tail (list);                                   \
}                                                                       \
                                                                        \
static int                                                              \
DCL(GENWRAP_PREFIX, cmp) (TYPE node1, TYPE node2)                       \
{                                                                       \
  return GLUE(bess_, GLUE(GENWRAP_PREFIX,_get_id)) (node1) <            \
         GLUE(bess_, GLUE(GENWRAP_PREFIX,_get_id)) (node2);             \
}                                                                       \
                                                                        \
static GENWRAP_LIST_TYPE(TYPE)                                          \
DCL(GENWRAP_PREFIX, l_ordered_copy) (GENWRAP_LIST_TYPE(TYPE) list)      \
{                                                                       \
  return sort_list_func (copy_list (list, NOT_NODES),                   \
                         DCL (GENWRAP_PREFIX, cmp));                    \
}                                                                       \
                                                                        \
static void                                                             \
DCL(GENWRAP_PREFIX, l_free) (GENWRAP_LIST_TYPE(TYPE) list)              \
{                                                                       \
  free_list (list, NOT_NODES);                                          \
}

SPLURGE (GENWRAP_TYPE)

#undef GENWRAP_TYPE
#undef GENWRAP_PREFIX
