#ifndef SMESH_H
#  define SMESH_H
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <limits.h>
#include <sys/stat.h>
#include <unistd.h>
#include <float.h>

#if HAVE_STRING_H
#      include <string.h>
#else
#  if HAVE_STRINGS_H
#         include <strings.h>
#  endif
#endif

#include "newP.h"              /* Ckit library */
#include "ioP.h"              /* Ckit library */
#include "listP.h"              /* Ckit library */
#include "dictP.h"              /* Ckit library */
#include "hashP.h"              /* Ckit library */
#define VECMAC_VECTOR_TYPE 1
#include "vecmacP.h" 
#define WANT_VECTP_ALIASES
#include "vectP.h" /* to be able to use vector library routines. */
#include "tokensP.h"            /* Ckit library */
#include "expevalP.h" /* to be able to use expeval library routines. */
#include "gaussP.h" /* to be able to use gauss library routines. */
#include "randP.h" /* to be able to use rand library routines. */


/* G3D library */
#include "g3d.h"

/* PiRaT library */
#include "pirat.h"

struct smesh_triangulation_t;
struct smesh_triangle_t;
struct smesh_edge_t;
struct smesh_vertex_t;

typedef struct smesh_triangle_t *smesh_triangle_p;
typedef struct smesh_edge_t *smesh_edge_p;
typedef struct smesh_vertex_t *smesh_vertex_p;
typedef struct smesh_triangulation_t *smesh_triangulation_p;


typedef CkitPoint3 smesh_loc_t;


typedef int (*smesh_error_notify_func) (smesh_triangulation_p,
                                        char *file,
                                        int line,
                                        char *msg);


#include "smesh.pt"

#endif /* SMESH_H */
