#! /bin/ksh -f

function usage {
cat <<EOF
Usage: $(basename $0) [ list of egf files ]
Default (if list not given): test all files in the BESS egf directory
EOF
}

if [ $# -gt 1 ] ; then
    l=$1
else
    l=$(ls ../egf | egrep '.egf')
fi

function warn {
   echo "****** WARNING \c"
   echo $*
}

for n in $l
do
   input=${n##../egf}
   n="$input"
   input=${n%%.egf}
   echo Running for $input
   run_egfbess $input -test
   if [ -f ../topo/$input.topo ] ; then
      if [ $(diff ./$input.topo ../topo/$input.topo | wc -l) -gt 1 ] ; then
         warn diff ./$input.topo ../topo/$input.topo
      fi
   fi
   if [ $(grep Inconsistent ./$input.topo | wc -l) -ge 1 ] ; then
      warn Inconsistent Euler characteristics
   fi
done
