#ifndef TETMESH_H
#  define TETMESH_H

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <limits.h>
#include <sys/stat.h>
#include <unistd.h>
#include <float.h>

#if HAVE_STRING_H
#      include <string.h>
#else
#  if HAVE_STRINGS_H
#         include <strings.h>
#  endif
#endif


#undef NDEBUG
#include <assert.h>

#include "newP.h"              /* Ckit library */
#include "ioP.h"              /* Ckit library */
#include "listP.h"              /* Ckit library */
#include "dictP.h"              /* Ckit library */
#include "hashP.h"              /* Ckit library */
#define VECMAC_VECTOR_TYPE 1
#include "vecmacP.h" 
#define WANT_VECTP_ALIASES
#include "vectP.h" /* to be able to use vector library routines. */
#include "tokensP.h"            /* Ckit library */
#include "expevalP.h" /* to be able to use expeval library routines. */
#include "gaussP.h" /* to be able to use gauss library routines. */
#include "randP.h" /* to be able to use rand library routines. */


/* G3D library */
#include "g3d.h"

struct tet_triangulation_t;
struct tet_tet_t;
struct tet_face_t;
struct tet_edge_t;
struct tet_vertex_t;

typedef struct tet_tet_t *tet_tet_p;
typedef struct tet_face_t *tet_face_p;
typedef struct tet_edge_t *tet_edge_p;
typedef struct tet_vertex_t *tet_vertex_p;
typedef struct tet_triangulation_t *tet_triangulation_p;


typedef CkitPoint3 tet_loc_t;


typedef int (*tet_error_notify_func) (tet_triangulation_p,
                                        char *file,
                                        int line,
                                        char *msg);


#include "tetmesh.pt"

#endif /* TETMESH_H */
